<?php 
namespace Am\Controllers;
use App\Controllers\BaseController;
include_once("I18n.php");
include_once("BxPage.php");
use I18n;
use BxPage;

class Amstatus extends BaseController {
    /**
     * Constructor.
     *
     */
    public function __construct() {
        
    }
    
    /**
     * Index
     *
     * @return View
     */
    public function index() {

        //helper(['form']);

        $CI =& get_instance();

        if (!$CI->getAllowed('serverShowActiveMonitor')) {
            // Nice people say goodbye, or CCEd waits forever:
            $CI->cceClient->bye();
            $CI->serverScriptHelper->destructor();
            Log403Error("/gui/Forbidden403");
        }

        //
        //--- Get CODB-Object of interest: 
        //

        $CODBDATA = $CI->cceClient->getObject("ActiveMonitor");

        // Prepare Page:
        $factory = $CI->serverScriptHelper->getHtmlComponentFactory("base-am", "/am/amStatus");
        $BxPage = $factory->getPage();
        $i18n = $factory->getI18n();
        $BxPage->setGETPOST(array('FORM_GET' => $this->request->getGet(), 'FORM_POST' => $this->request->getPost(), 'AGENT' => $this->request->getUserAgent()));

        //
        //-- Re-Use $errors array from Session data:
        //

        $errors = $BxPage->getErrors();

        // Prepare Page:
        $BxPage->setFormUrl("/am/amStatus");
        $BxPage->setErrors($errors);

        // Set Menu items:
        $BxPage->setVerticalMenu('base_monitor');
        $BxPage->setVerticalMenuChild('base_amStatus');
        $page_module = 'base_sysmanage';

        $defaultPage = "basicSettingsTab";

        $block = $factory->getPagedBlock("amSysClients", array($defaultPage));
        $block->setToggle("#");
        $block->setSideTabs(FALSE);
        $block->setDefaultPage($defaultPage);

        // Generate "Check Status Now" button:
        $updateButton = $factory->getButton('/am/amStatusUpdate', 'amUpdateNow', 'DEMO-OVERRIDE');
        $updateButton->setIcon('fa fa-refresh');
        $updateButton->setWaiter(TRUE);
        $updateButton->setImageOnly(FALSE);
        $updateButton->setButtonColor('primary');

        // If Active Monitor is disabled, we disable the Update button, too:
        if ($CODBDATA['enabled'] == '0') {
            $updateButton->setDisabled(true);
        }

        // Add "Check Status Now" Button-Container:
        $buttonContainer = $factory->getButtonContainer("", array($updateButton));
        $buttonContainer->setMargin('ml-10');

        // Create System-ScrollList:
        $syslist = $factory->getScrollList("amSysClients", array(' ', 'amClientName', 'action'), array()); 
        $syslist->setAlignments(array("center", "left", "center"));
        $syslist->setDefaultSortedIndex('1');
        $syslist->setSortOrder('ascending');
        $syslist->setSortDisabled(array('0', '2'));
        $syslist->setPaginateDisabled(TRUE);
        $syslist->setSearchDisabled(TRUE);
        $syslist->setSelectorDisabled(FALSE);
        $syslist->enableAutoWidth(FALSE);
        $syslist->setInfoDisabled(FALSE);
        $syslist->setColumnWidths(array("50", "*", "150")); // Max: 739px

        $block2 = $factory->getPagedBlock("amServClients", array($defaultPage));
        $block2->setToggle("#");
        $block2->setSideTabs(FALSE);
        $block2->setDefaultPage($defaultPage);


        // Create Service-ScrollList:
        $servlist = $factory->getScrollList("amServClients", array(' ', 'amClientName', 'action'), array()); 
        $servlist->setAlignments(array("center", "left", "center"));
        $servlist->setDefaultSortedIndex('1');
        $servlist->setSortOrder('ascending');
        $servlist->setSortDisabled(array('0', '2'));
        $servlist->setPaginateDisabled(TRUE);
        $servlist->setSearchDisabled(TRUE);
        $servlist->setSelectorDisabled(FALSE);
        $servlist->enableAutoWidth(FALSE);
        $servlist->setInfoDisabled(FALSE);
        $servlist->setColumnWidths(array("50", "*", "150")); // Max: 739px       

        $am_names = $CI->cceClient->names("ActiveMonitor");

        $stmap = array(
            "N" => "none", 
            "G" => "normal", 
            "Y" => "problem", 
            "R" => "severeProblem");

        $colormap = array(
            "N" => "light", 
            "G" => $BxPage->getPrimaryColor(), 
            "Y" => "orange", 
            "R" => "red");

        $iconmap = array(
            "N" => "ui-icon-radio-on", 
            "G" => "ui-icon-check", 
            "Y" => "ui-icon-notice", 
            "R" => "ui-icon-alert");

        $descmap = array(
            "N" => "amKeyGrey", 
            "G" => "amKeyGreen", 
            "Y" => "amKeyYellow", 
            "R" => "amKeyRed");

        for ($i=0; $i < count($am_names); ++$i) {
            $nspace = $CI->cceClient->get($CODBDATA['OID'], $am_names[$i]);

            if (!isset($nspace["hideUI"])) {
                $iname = $i18n->interpolate($nspace["nameTag"]);

                if (($CODBDATA['enabled'] == '0') || (!$nspace["enabled"]) || (!$nspace["monitor"])) {
                    //$icon = '<button class="light small icon_only tooltip hover" title="' . $i18n->getHtml("amKeyGrey") . '"><div class="ui-icon ui-icon-radio-on"></div></button>';
                    $am_statusButton = $factory->getButton('javascript:void(0);', $i18n->getHtml("amKeyGrey"), 'DEMO-OVERRIDE');
                    $am_statusButton->setButtonSize('small');
                    $am_statusButton->setImageOnly(TRUE);
                    $am_statusButton->setIcon('fa fa-circle-o');
                    $am_statusButton->setButtonDisabled(TRUE);
                    $am_statusButton->setButtonSpecialStyle('square_animated');
                    $am_statusButton->setButtonColor('default');
                    $icon = $factory->getCompositeFormField(array($am_statusButton));
                    $icon->setAlignment('center');
                } 
                else {
                    //$icon = '<button class="' . $colormap[$nspace["currentState"]] . ' small icon_only tooltip hover" title="' . $i18n->getHtml($descmap[$nspace["currentState"]]) . '"><div class="ui-icon ' . $iconmap[$nspace["currentState"]] . '"></div></button>';
                    $am_statusButton = $factory->getButton('javascript:void(0);', $i18n->getHtml($descmap[$nspace["currentState"]]), 'DEMO-OVERRIDE');
                    $am_statusButton->setButtonSize('small');
                    $am_statusButton->setImageOnly(TRUE);
                    $am_statusButton->setButtonDisabled(TRUE);
                    $am_statusButton->setButtonSpecialStyle('square_animated');

                    if ($nspace["currentState"] == "R") {
                        $am_statusButton->setIcon('fa fa-warning');
                        $am_statusButton->setButtonColor('danger');
                    }
                    elseif ($nspace["currentState"] == "Y") {
                        $am_statusButton->setButtonColor('warning');
                        $am_statusButton->setIcon('fa fa-warning');
                    }
                    elseif (($nspace["currentState"] == "N") || ($nspace["currentState"] == "")) {
                        $am_statusButton->setButtonColor('default');
                        $am_statusButton->setIcon('fa fa-circle-o');
                    }
                    else {
                        $am_statusButton->setButtonColor('primary');
                        $am_statusButton->setIcon('fa fa-check');
                    }
                    $icon = $factory->getCompositeFormField(array($am_statusButton));
                    $icon->setAlignment('center');
                }

                $namefield = $iname;

                // The NameSpace URL is the URL to the BlueOnyx 510XR version of that page.
                // For 520XR we need to adjust that to the CodeIgniter URL format:
                $URL_elements = explode('/', $nspace["URL"]);

                // Get Vendor of the AM-page:
                if (!empty($URL_elements[1])) {
                    $vendor = $URL_elements[1];
                }

                // Get Module of the AM-Page:
                $module = $URL_elements[2];

                // Get Filename of the AM-Page:
                $fileName_elements = explode('.', $URL_elements[3]);
                $filename = $fileName_elements[0];

                // Put it back together:
                $nspace["URL"] = '/' . $module . '/' . $filename;

                $fancy_button = $factory->getFancyButton($nspace["URL"] . "?short=1", "", "DEMO-OVERRIDE");
                $fancy_button->setButtonSize("small");
                $fancy_button->setImageOnly(TRUE);

                $link_button = $factory->getLinkButton($nspace["URL"], "[[palette.detail]]", "DEMO-OVERRIDE");
                $link_button->setButtonSize("small");
                $link_button->setImageOnly(TRUE);

                $details = $factory->getCompositeFormField(array($fancy_button, $link_button));
                $details->setAlignment('right');
                if (($nspace["URL"] == "") || (!is_file("/usr/sausalito/ui/chorizo/ci4/Modules/" . ucfirst($vendor) . "/" . ucfirst($module) . "/Controllers/" . ucfirst($filename) . ".php"))) {
                    $fancy_button->setDisabled(TRUE);
                    $link_button->setDisabled(TRUE);
                }

                if ($nspace["UIGroup"] == "system") {
                    $syslist->addEntry(array($icon, $namefield, $details));
                }
                elseif ($nspace["UIGroup"] == "service") {
                    $servlist->addEntry(array($icon, $namefield, $details));
                }
                else {
                    if (!$otherlist) { 
                        // Create Other-ScrollList:
                        $otherlist = $factory->getScrollList("amOtherClients", array(' ', 'amClientName', 'action'), array()); 
                        $otherlist->setAlignments(array("center", "left", "center"));
                        $otherlist->setDefaultSortedIndex('1');
                        $otherlist->setSortOrder('ascending');
                        $otherlist->setSortDisabled(array('2'));
                        $otherlist->setPaginateDisabled(TRUE);
                        $otherlist->setSearchDisabled(TRUE);
                        $otherlist->setSelectorDisabled(FALSE);
                        $otherlist->enableAutoWidth(FALSE);
                        $otherlist->setInfoDisabled(FALSE);
                        $otherlist->setColumnWidths(array("100", "500", "120")); // Max: 739px   
                    }
                    $otherlist->addEntry(array($icon, $namefield, $details));
                }
            }
        }

        // Push out the System-Scrollist:
        $xxx = $factory->getRawHTML("amSysClients", $syslist->toHtml());
        $block->addFormField(
            $xxx,
            $factory->getLabel("amSysClients"),
            $defaultPage
        );

        // Push out the Service-Scrollist:
        $xxx = $factory->getRawHTML("amServClients", $servlist->toHtml());
        $block2->addFormField(
            $xxx,
            $factory->getLabel("amServClients"),
            $defaultPage
        );

        if (isset($otherlist)) {
            // Push out the Other-Scrollist:
            $xxx = $factory->getRawHTML("amOtherClients", $servlist->toHtml());
            $block3->addFormField(
                $xxx,
                $factory->getLabel("amOtherClients"),
                $defaultPage
            );
        }

        $page_body[] = $buttonContainer->toHtml();

        if ($CI->BX_SESSION['gui_theme'] === 'elmer') {
            $page_body[] = StartPageStats($CI->cceClient, $BxPage, $i18n);
        }

        $page_body[] = $block->toHtml();
        $page_body[] = $block2->toHtml();
        if (isset($otherlist)) {
            $page_body[] = $block3->toHtml();
        }

        // Out with the page:
        return $BxPage->render($page_module, $page_body);
    }

    public function update() {

        $CI =& get_instance();

        if (!$CI->getAllowed('serverShowActiveMonitor')) {
            // Nice people say goodbye, or CCEd waits forever:
            $CI->cceClient->bye();
            $CI->serverScriptHelper->destructor();
            Log403Error("/gui/Forbidden403");
        }

        //
        //--- User initiated update of AM-Status - run Swatch:
        //

        //$ret = $CI->serverScriptHelper->shell("/usr/sbin/swatch -c /etc/swatch.conf", $output, "root", $CI->BX_SESSION['sessionId']);
        $ret = $CI->serverScriptHelper->fork("/usr/sbin/swatch -c /etc/swatch.conf", "root");
        // Nice people say goodbye, or CCEd waits forever:
        $CI->cceClient->bye();
        $CI->serverScriptHelper->destructor();
        return redirect()->to(base_url() . '/am/amStatus');
    }

}

/*
Copyright (c) 2008-2023 Michael Stauber, SOLARSPEED.NET
Copyright (c) 2008-2023 Team BlueOnyx, BLUEONYX.IT
All Rights Reserved.

1. Redistributions of source code must retain the above copyright 
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright 
   notice, this list of conditions and the following disclaimer in 
   the documentation and/or other materials provided with the 
   distribution.

3. Neither the name of the copyright holder nor the names of its 
   contributors may be used to endorse or promote products derived 
   from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE.

You acknowledge that this software is not designed or intended for 
use in the design, construction, operation or maintenance of any 
nuclear facility.

*/